//
// Test application
//
// AvkonVideoOverlay
// solidcontrol.h
//

#ifndef SOLIDCONTROL_H
#define SOLIDCONTROL_H

#include <w32std.h>
#include <coecntrl.h>

class CGraphicsSurface;

// Window-owning control which renders a solid opaque block
// If aCreateSurface is true, a graphics surface is created, filled with solid colour,
// and bound to the control's window.
// If aCreateSurface is false, the solid colour is painted using a graphics context.
class CSolidControl : public CCoeControl
{
    // Give access to Components() array
    friend class CAvkonVideoOverlayAppUi;

public:
    CSolidControl();
    void ConstructL(TBool aCreateSurface = EFalse, CCoeControl* aParent = 0);
	~CSolidControl();

private:
	void SizeChanged();
	void Draw(const TRect& aRect) const;

private:
	TBool iCreateSurface;
    CGraphicsSurface* iSurface;
};

#endif // GRAPHICSSURFACE_H
