//
// Test application
//
// AvkonVideoOverlay
// videocontrol.cpp
//

#include "videocontrol.h"

_LIT(KFileName, "e:\\videos\\test.mp4");

CVideoControl::CVideoControl()
    {

    }

CVideoControl::~CVideoControl()
    {
    RDebug::Printf("CVideoControl::~CVideoControl 0x%08x", this);
    delete iPlayer;
    }

void CVideoControl::ConstructL(CCoeControl* aParent)
    {
    if (aParent)
        {
        CreateWindowL(aParent);
        }
    else
        {
        CreateWindowL(CCoeEnv::Static()->RootWin());
        }
    static_cast<RWindow&>(Window()).SetBackgroundColor(TRgb(0,0,0));
    InitComponentArrayL();
    const TInt priority = 0;
    const TMdaPriorityPreference preference = EMdaPriorityPreferenceNone;
    iPlayer = CVideoPlayerUtility2::NewL(*this, priority, preference);
    MakeVisible(ETrue);
    ActivateL();
    iPlayer->OpenFileL(KFileName);
    RDebug::Printf("CVideoControl::ConstructL 0x%08x parent 0x%08x window 0x%08x", this, aParent, &Window());
    }

void CVideoControl::SizeChanged()
    {
    for (CCoeControlArray::TCursor cursor = Components().Begin();
         Components().End() != cursor; cursor.Next())
        {
        cursor.Control<CCoeControl>()->SetRect(TRect(20, 20, Size().iWidth-20, Size().iHeight-20));
        }
    }

void CVideoControl::MvpuoOpenComplete(TInt aError)
    {
    RDebug::Printf("CVideoControl::MvpuoOpenComplete %d", aError);
    if (!aError)
        {
        iPlayer->Prepare();
        }
    }

void CVideoControl::MvpuoPrepareComplete(TInt aError)
    {
    RDebug::Printf("CVideoControl::MvpuoPrepareComplete %d", aError);
    if (!aError)
        {
        TRAPD(err, iPlayer->AddDisplayWindowL(CCoeEnv::Static()->WsSession(), *CCoeEnv::Static()->ScreenDevice(), static_cast<RWindow&>(Window()), Rect(), Rect()));
        RDebug::Printf("VideoContainerPrivate::MvpuoPrepareComplete %d", err);
        if (!err)
            {
            TRAP_IGNORE(iPlayer->SetVolumeL(0.25 * iPlayer->MaxVolume()));
            iPlayer->Play();
            }
        }
    }

void CVideoControl::MvpuoFrameReady(CFbsBitmap &, TInt)
    {

    }

void CVideoControl::MvpuoPlayComplete(TInt)
    {

    }

void CVideoControl::MvpuoEvent(const TMMFEvent &)
    {

    }


